<project xmlns="http://maven.apache.org/POM/4.0.0"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
	<modelVersion>4.0.0</modelVersion>
	<parent>
		<groupId>ch.dlcm</groupId>
		<artifactId>DLCM-Parent</artifactId>
		<version>3.0.0-SNAPSHOT</version>
	</parent>
	<artifactId>DLCM-Solution</artifactId>
	<name>DLCM Solution</name>
	<description>DLCM application wrapping all modules, All-In-One</description>
	<packaging>war</packaging>
	<properties>
		<!-- Mandatory property to prevent inheritance of the parent property.
		If not set the module in Sonar will be the same as the parent module -->
		<sonar.projectName>${project.name}</sonar.projectName>
	</properties>
	<dependencies>
		<!--DLCM dependencies -->
		<dependency>
			<groupId>ch.dlcm</groupId>
			<artifactId>DLCM-Admin</artifactId>
		</dependency>
		<dependency>
			<groupId>ch.dlcm</groupId>
			<artifactId>DLCM-PreservationPlanning</artifactId>
		</dependency>
		<dependency>
			<groupId>ch.dlcm</groupId>
			<artifactId>DLCM-PreIngest</artifactId>
		</dependency>
		<dependency>
			<groupId>ch.dlcm</groupId>
			<artifactId>DLCM-Ingest</artifactId>
		</dependency>
		<dependency>
			<groupId>ch.dlcm</groupId>
			<artifactId>DLCM-ArchivalStorage</artifactId>
		</dependency>
		<dependency>
			<groupId>ch.dlcm</groupId>
			<artifactId>DLCM-DataMgmt</artifactId>
		</dependency>
		<dependency>
			<groupId>ch.dlcm</groupId>
			<artifactId>DLCM-Access</artifactId>
		</dependency>
		<dependency>
			<groupId>ch.dlcm</groupId>
			<artifactId>DLCM-ResourceServerSecurity</artifactId>
		</dependency>
		<!--Solidify dependencies -->
		<dependency>
			<groupId>ch.unige.solidify</groupId>
			<artifactId>solidify-doc</artifactId>
			<scope>test</scope>
		</dependency>
		<!--Spring dependencies -->
		<dependency>
			<groupId>org.springframework.boot</groupId>
			<artifactId>spring-boot-starter-tomcat</artifactId>
		</dependency>
		<dependency>
			<groupId>org.springframework.cloud</groupId>
			<artifactId>spring-cloud-config-client</artifactId>
		</dependency>
		<dependency>
			<groupId>org.springframework.boot</groupId>
			<artifactId>spring-boot-starter-thymeleaf</artifactId>
		</dependency>
		<dependency>
			<groupId>io.micrometer</groupId>
			<artifactId>micrometer-registry-prometheus</artifactId>
		</dependency>
	</dependencies>
	<build>
		<plugins>
			<plugin>
				<groupId>io.github.git-commit-id</groupId>
				<artifactId>git-commit-id-maven-plugin</artifactId>
			</plugin>
			<plugin>
				<groupId>org.springframework.boot</groupId>
				<artifactId>spring-boot-maven-plugin</artifactId>
				<configuration>
					<mainClass>ch.dlcm.SolutionApplication</mainClass>
				</configuration>
				<executions>
					<execution>
						<goals>
							<goal>repackage</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-surefire-plugin</artifactId>
				<configuration>
					<includes>
						<include>**/*Documentation.java</include>
					</includes>
					<argLine>-Dfile.encoding=UTF-8 -XX:+EnableDynamicAgentLoading</argLine>
					<systemPropertyVariables>
						<server.servlet.context-path>/dlcm</server.servlet.context-path>
					</systemPropertyVariables>
				</configuration>
			</plugin>
			<plugin>
				<groupId>org.asciidoctor</groupId>
				<artifactId>asciidoctor-maven-plugin</artifactId>
				<configuration>
					<attributes>
						<applicationName>${project.name}</applicationName>
						<applicationDescription>${project.description}</applicationDescription>
						<admin />
						<preingest />
						<ingest />
						<archivalStorage />
						<preservationPlanning />
						<dataMgmt />
						<access />
						<resourceSrv />
					</attributes>
				</configuration>
			</plugin>
			<plugin>
				<groupId>ch.unige.solidify</groupId>
				<artifactId>solidify-asciidoctor-toc-maven-plugin</artifactId>
				<version>${dlcm.tool.asciidoctor.toc.version}</version>
				<executions>
					<execution>
						<id>integration</id>
						<goals>
							<goal>extract-toc</goal>
						</goals>
						<configuration>
							<inputFile>
								${project.build.directory}/generated-docs/DLCM-IntegrationGuide.html</inputFile>
						</configuration>
					</execution>
					<execution>
						<id>tools</id>
						<goals>
							<goal>extract-toc</goal>
						</goals>
						<configuration>
							<skip>${skipTools}</skip>
							<inputFile>
								${project.build.directory}/generated-docs/DLCM-ToolsGuide.html</inputFile>
						</configuration>
					</execution>
				</executions>
				<configuration>
					<skip>${skipTests}</skip>
				</configuration>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-resources-plugin</artifactId>
				<executions>
					<execution>
						<id>copy-resources-docs</id>
						<phase>prepare-package</phase>
						<goals>
							<goal>copy-resources</goal>
						</goals>
						<configuration>
							<outputDirectory>
								${project.build.outputDirectory}/static/docs</outputDirectory>
							<resources>
								<resource>
									<directory>
										${project.build.directory}/generated-docs</directory>
								</resource>
							</resources>
						</configuration>
					</execution>
					<execution>
						<id>copy-resources-openapi-specs</id>
						<phase>prepare-package</phase>
						<goals>
							<goal>copy-resources</goal>
						</goals>
						<configuration>
							<outputDirectory>
								${project.build.outputDirectory}/static/docs/openapi</outputDirectory>
							<resources>
								<resource>
									<directory>
										${project.build.directory}/openapi-spec/</directory>
									<include>dlcm-openapi-*.json</include>
								</resource>
							</resources>
						</configuration>
					</execution>
					<execution>
						<id>copy-resources-dlcm-tools</id>
						<phase>prepare-package</phase>
						<goals>
							<goal>copy-resources</goal>
						</goals>
						<configuration>
							<skip>${skipTools}</skip>
							<outputDirectory>
								${project.build.outputDirectory}/static/docs/packages</outputDirectory>
							<resources>
								<resource>
									<directory>../DLCM-Tools/target/</directory>
									<include>DLCM-Tools-*.jar</include>
								</resource>
							</resources>
						</configuration>
					</execution>
				</executions>
			</plugin>
		</plugins>
	</build>
</project>
